CREATE OR REPLACE PROCEDURE ARQUIVO_GI(
   P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA   IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA  IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DECLARACAO  IN NOTAFISCAL.IDSTATUS%TYPE,
   P_SITUACAO    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_CFDF        IN EMPRESA.CDINSCESTA%TYPE,
   P_NRSEQARQMAG IN NOTAFISCAL.NRLANCTONF%TYPE)
AS
   V_SGESTADO      VARCHAR2(02);
   V_VRBASECALCNF  NUMBER;
   V_VRIMPOSTONF   NUMBER;
   V_VROUTRCRED    NUMBER;
   V_EMPRESA       VARCHAR2(400);
   V_CDSITUTRIB    VARCHAR2(02);
   V_RESPONSAVL    VARCHAR2(400);
   V_CONTADOR      NUMBER;
   V_SEQMAGNET     VARCHAR2(20);
BEGIN

  /* sequencial para gerao do livro eletrnico */
  V_SEQMAGNET := P_NRSEQARQMAG;

   BEGIN
      SELECT TO_CHAR(SYSDATE, 'ddmmyyyy')||
             TO_CHAR(SYSDATE,'hh24miss')||
             RPAD(NVL(P_CFDF,' '), 13, ' ')||
             P_DECLARACAO||
             TO_CHAR(SYSDATE, 'yyyy')||
             RPAD(NVL(NMRAZSOCEMPR,' '), 50, ' ')||
             NRINSJUREMPR||
             RPAD(NVL(DSENDEEMPR,' '), 50, ' ')||
             NRCEPEMPR||
             RPAD(' ', 8, ' ')||
             P_SITUACAO,
             LPAD(NVL(NMRESPONSAVL,' '), 40, ' ')||
             NRCPFRESPONS||
             RPAD(' ', 25, ' ')
      INTO V_EMPRESA, V_RESPONSAVL
      FROM CONTADOR C, EMPRESA E, INSCRESTAD IE
      WHERE C.CDCONTADOR2 = IE.CDCONTADOR2
        AND E.CDEMPRESA = P_CDEMPRESA
        AND IE.CDINSCESTA = P_CDINSCESTA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EMPRESA    := NULL;
         V_RESPONSAVL := NULL;
   END;


   V_CONTADOR := 0000000000;
   FOR C_NOTAS IN (SELECT (NF.ESTADO||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRBASE_E),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRIMP_E),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VROUT_E),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRPETRO_E),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRPRODUTOS_E),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRBASE_S),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRIMPO_S),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VROUTR_S),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRSUBS_S),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRCONTNCONT),'00000000000.00'),'.',''))||
                           LTRIM(REPLACE(TO_CHAR(SUM(NF.VRBASENCONT),'00000000000.00'),'.',''))) AS DADOS
                   FROM(SELECT ES.CDESTAEXPO AS ESTADO,
                               SUM(VRBASECALCNF) AS VRBASE_E,
                               SUM(VRIMPOSTONF) AS VRIMP_E,
                               SUM(VROUTRCRED) AS VROUT_E,
                               0 AS VRPETRO_E,
                               0 AS VRPRODUTOS_E,
                               0 AS VRBASE_S,
                               0 AS VRIMPO_S,
                               0 AS VROUTR_S,
                               0 AS VRSUBS_S,
                               0 AS VRCONTNCONT, /* valor contbil nao contribuinte */
                               0 as VRBASENCONT /* valor de base de calculo nao contribuinte */
                        FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN E, ESTADO ES,
                             (SELECT I.CDFILIAL, I.NRLANCTONF,
                                     SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                     SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED
                              FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IP
                              WHERE M.CDEMPRESA     = P_CDEMPRESA
                                AND M.CDINSCESTA    = P_CDINSCESTA
                                AND M.CDIMPOSTO     = P_CDIMPOSTO
                                AND M.DTINIPERIODO  = P_DTINICIAL
                                AND M.DTFIMPERIODO  = P_DTFINAL
                                AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                AND IP.CDIMPOSTO    = I.CDIMPOSTO
                                AND SUBSTR(I.CDFISCOPERNF,1,1) IN('1','2','3')
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                              GROUP BY I.CDFILIAL, I.NRLANCTONF) I
                        WHERE ((IDSTATUS = 'A') OR (IDSTATUS = 'E'))
                          AND IDENTRSAIDOP = 'E'
                          AND I.NRLANCTONF = N.NRLANCTONF
                          AND I.CDFILIAL = N.CDFILIAL
                          AND N.CDFORNECED = F.CDFORNECED
                          AND F.CDFORNECED = E.CDFORNECED
                          AND ES.CDPAIS = E.CDPAIS
                          AND ES.SGESTADO = E.SGESTADO
                          AND E.IDTPENDEFORN(+) = NVL(F.IDENDEMISFOR,'P')
                        GROUP BY ES.CDESTAEXPO
                        UNION ALL
                        SELECT ES.CDESTAEXPO AS ESTADO,
                               SUM(VRBASECALCNF) AS VRBASE_E,
                               SUM(VRIMPOSTONF) AS VRIMP_E,
                               SUM(VROUTRCRED) AS VROUT_E,
                               0 AS VRPETRO_E,
                               0 AS VRPRODUTOS_E,
                               0 AS VRBASE_S,
                               0 AS VRIMPO_S,
                               0 AS VROUTR_S,
                               0 AS VRSUBS_S,
                               0 AS VRCONTNCONT, /* valor contbil nao contribuinte */
                               0 as VRBASENCONT /* valor de base de calculo nao contribuinte */
                        FROM NOTAFISCAL N, CLIENTE C, ENDECLIE E, ESTADO ES,
                             (SELECT I.CDFILIAL, I.NRLANCTONF,
                                     SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                     SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED
                              FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IP
                              WHERE M.CDEMPRESA     = P_CDEMPRESA
                                AND M.CDINSCESTA    = P_CDINSCESTA
                                AND M.CDIMPOSTO     = P_CDIMPOSTO
                                AND M.DTINIPERIODO  = P_DTINICIAL
                                AND M.DTFIMPERIODO  = P_DTFINAL
                                AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                AND IP.CDIMPOSTO    = I.CDIMPOSTO
                                AND SUBSTR(I.CDFISCOPERNF,1,1) IN('1','2','3')
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                              GROUP BY I.CDFILIAL, I.NRLANCTONF) I
                        WHERE ((IDSTATUS = 'A') OR (IDSTATUS = 'E'))
                          AND IDENTRSAIDOP = 'E'
                          AND I.NRLANCTONF = N.NRLANCTONF
                          AND I.CDFILIAL = N.CDFILIAL
                          AND N.CDCLIENTE = C.CDCLIENTE
                          AND C.CDCLIENTE = E.CDCLIENTE
                          AND ES.CDPAIS = E.CDPAIS
                          AND ES.SGESTADO = E.SGESTADO
                          AND E.IDTPENDECLIE(+) = NVL(C.IDENDEMISCLI,'P')
                        GROUP BY ES.CDESTAEXPO
                        UNION ALL
                        SELECT DECODE(NVL(F.IDENDEMISFIL,'P'),'I',EI.CDESTAEXPO,ES.CDESTAEXPO) AS ESTADO,
                               SUM(VRBASECALCNF) AS VRBASE_E,
                               SUM(VRIMPOSTONF) AS VRIMP_E,
                               SUM(VROUTRCRED) AS VROUT_E,
                               0 AS VRPETRO_E,
                               0 AS VRPRODUTOS_E,
                               0 AS VRBASE_S,
                               0 AS VRIMPO_S,
                               0 AS VROUTR_S,
                               0 AS VRSUBS_S,
                               0 AS VRCONTNCONT, /* valor contbil nao contribuinte */
                               0 as VRBASENCONT /* valor de base de calculo nao contribuinte */
                        FROM NOTAFISCAL N, FILIAL F, ENDEFILI E, ESTADO ES, INSCRESTAD IE, ESTADO EI,
                             (SELECT I.CDFILIAL, I.NRLANCTONF,
                                     SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                     SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED
                              FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IP
                              WHERE M.CDEMPRESA     = P_CDEMPRESA
                                AND M.CDINSCESTA    = P_CDINSCESTA
                                AND M.CDIMPOSTO     = P_CDIMPOSTO
                                AND M.DTINIPERIODO  = P_DTINICIAL
                                AND M.DTFIMPERIODO  = P_DTFINAL
                                AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                AND IP.CDIMPOSTO    = I.CDIMPOSTO
                                AND SUBSTR(I.CDFISCOPERNF,1,1) IN('1','2','3')
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                              GROUP BY I.CDFILIAL, I.NRLANCTONF) I
                        WHERE ((IDSTATUS = 'A') OR (IDSTATUS = 'E'))
                          AND IDENTRSAIDOP = 'E'
                          AND I.NRLANCTONF = N.NRLANCTONF
                          AND I.CDFILIAL   = N.CDFILIAL
                          AND N.CDFILIEMIT = F.CDFILIAL
                          AND F.CDFILIAL   = E.CDFILIAL(+)
                          AND E.IDTPENDEFILI(+) = NVL(F.IDENDEMISFIL,'P')
                          AND N.CDINSCESTA = IE.CDINSCESTA
                          AND N.CDEMPRESA  = IE.CDEMPRESA
                          AND NVL(E.CDPAIS,IE.CDPAIS)    = ES.CDPAIS
                          AND NVL(E.SGESTADO,IE.SGESTADO)= ES.SGESTADO
                          AND EI.CDPAIS    = IE.CDPAIS
                          AND EI.SGESTADO  = IE.SGESTADO
                        GROUP BY DECODE(NVL(F.IDENDEMISFIL,'P'),'I',EI.CDESTAEXPO,ES.CDESTAEXPO)
                        --SAIDA
                        UNION
                        SELECT ES.CDESTAEXPO AS ESTADO,
                               0 AS VRBASE_E,
                               0 AS VRIMP_E,
                               0 AS VROUT_E,
                               0 AS VRPETRO_E,
                               0 AS VRPRODUTOS_E,
                               SUM(VRBASECALCNF) AS VRBASE_S,
                               SUM(VRIMPOSTONF) AS VRIMPO_S,
                               SUM(VROUTRCRED) AS VROUTR_S,
                               SUM(VRSUBSTRIB) AS VRSUBS_S,
                               SUM(VRCONTNCONT) AS VRCONTNCONT,
                               SUM(VRBASENCONT) AS VRBASENCONT
                        FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN E, ESTADO ES,
                             (SELECT I.CDFILIAL, I.NRLANCTONF,
                                     SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                     SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED,
                                     SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'I' )) AS VRSUBSTRIB,
                                     SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)) AS VRCONTNCONT,  /* valor contbil nao contribuinte */
                                     SUM(DECODE(I.CDFISCALNF,'2',I.VRBASECALCNF,0)) AS VRBASENCONT   /* valor de base de calculo nao contribuinte */
                              FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IP
                              WHERE M.CDEMPRESA     = P_CDEMPRESA
                                AND M.CDINSCESTA    = P_CDINSCESTA
                                AND M.CDIMPOSTO     = P_CDIMPOSTO
                                AND M.DTINIPERIODO  = P_DTINICIAL
                                AND M.DTFIMPERIODO  = P_DTFINAL
                                AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                AND IP.CDIMPOSTO    = I.CDIMPOSTO
                                AND SUBSTR(I.CDFISCOPERNF,1,1) IN('5','6','7')
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                              GROUP BY I.CDFILIAL, I.NRLANCTONF) I
                        WHERE ((IDSTATUS = 'A') OR (IDSTATUS = 'E'))
                          AND IDENTRSAIDOP = 'S'
                          AND I.NRLANCTONF = N.NRLANCTONF
                          AND I.CDFILIAL = N.CDFILIAL
                          AND N.CDFORNECED = F.CDFORNECED
                          AND F.CDFORNECED = E.CDFORNECED
                          AND ES.CDPAIS = E.CDPAIS
                          AND ES.SGESTADO = E.SGESTADO
                          AND E.IDTPENDEFORN(+) = NVL(F.IDENDEMISFOR,'P')
                        GROUP BY ES.CDESTAEXPO
                        UNION ALL
                        --CLIENTE
                        SELECT ES.CDESTAEXPO AS ESTADO,
                               0 AS VRBASE_E,
                               0 AS VRIMP_E,
                               0 AS VROUT_E,
                               0 AS VRPETRO_E,
                               0 AS VRPRODUTOS_E,
                               SUM(VRBASECALCNF) AS VRBASE_S,
                               SUM(VRIMPOSTONF) AS VRIMPO_S,
                               SUM(VROUTRCRED) AS VROUTR_S,
                               SUM(VRSUBSTRIB) AS VRSUBS_S,
                               SUM(VRCONTNCONT) AS VRCONTNCONT,
                               SUM(VRBASENCONT) AS VRBASENCONT
                        FROM NOTAFISCAL N, CLIENTE C, ENDECLIE E, ESTADO ES,
                             (SELECT I.CDFILIAL, I.NRLANCTONF,
                                     SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                     SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED,
                                     SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'I')) AS VRSUBSTRIB,
                                     SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)) AS VRCONTNCONT,  /* valor contbil nao contribuinte */
                                     SUM(DECODE(I.CDFISCALNF,'2',I.VRBASECALCNF,0)) AS VRBASENCONT   /* valor de base de calculo nao contribuinte */
                              FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IP
                              WHERE M.CDEMPRESA     = P_CDEMPRESA
                                AND M.CDINSCESTA    = P_CDINSCESTA
                                AND M.CDIMPOSTO     = P_CDIMPOSTO
                                AND M.DTINIPERIODO  = P_DTINICIAL
                                AND M.DTFIMPERIODO  = P_DTFINAL
                                AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                AND IP.CDIMPOSTO    = I.CDIMPOSTO
                                AND SUBSTR(I.CDFISCOPERNF,1,1) IN('5','6','7')
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                              GROUP BY I.CDFILIAL, I.NRLANCTONF) I
                        WHERE ((IDSTATUS = 'A') OR (IDSTATUS = 'E'))
                          AND IDENTRSAIDOP = 'S'
                          AND I.NRLANCTONF = N.NRLANCTONF
                          AND I.CDFILIAL = N.CDFILIAL
                          AND N.CDCLIENTE = C.CDCLIENTE
                          AND C.CDCLIENTE = E.CDCLIENTE
                          AND ES.CDPAIS = E.CDPAIS
                          AND ES.SGESTADO = E.SGESTADO
                          AND E.IDTPENDECLIE(+) = NVL(C.IDENDEMISCLI,'P')
                        GROUP BY ES.CDESTAEXPO
                        UNION ALL
                        SELECT DECODE(NVL(F.IDENDEMISFIL,'P'),'I',EI.CDESTAEXPO,ES.CDESTAEXPO) AS ESTADO,
                               0 AS VRBASE_E,
                               0 AS VRIMP_E,
                               0 AS VROUT_E,
                               0 AS VRPETRO_E,
                               0 AS VRPRODUTOS_E,
                               SUM(VRBASECALCNF) AS VRBASE_S,
                               SUM(VRIMPOSTONF) AS VRIMPO_S,
                               SUM(VROUTRCRED) AS VROUTR_S,
                               SUM(VRSUBSTRIB) AS VRSUBS_S,
                               SUM(VRCONTNCONT) AS VRCONTNCONT,
                               SUM(VRBASENCONT) AS VRBASENCONT
                        FROM NOTAFISCAL N, FILIAL F, ENDEFILI E, ESTADO ES, INSCRESTAD IE, ESTADO EI,
                             (SELECT I.CDFILIAL, I.NRLANCTONF,
                                     SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                     SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED,
                                     SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'I')) AS VRSUBSTRIB,
                                     SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)) AS VRCONTNCONT,  /* valor contbil nao contribuinte */
                                     SUM(DECODE(I.CDFISCALNF,'2',I.VRBASECALCNF,0)) AS VRBASENCONT   /* valor de base de calculo nao contribuinte */
                              FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IP
                              WHERE M.CDEMPRESA     = P_CDEMPRESA
                                AND M.CDINSCESTA    = P_CDINSCESTA
                                AND M.CDIMPOSTO     = P_CDIMPOSTO
                                AND M.DTINIPERIODO  = P_DTINICIAL
                                AND M.DTFIMPERIODO  = P_DTFINAL
                                AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                AND IP.CDIMPOSTO    = I.CDIMPOSTO
                                AND SUBSTR(I.CDFISCOPERNF,1,1) IN('5','6','7')
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                              GROUP BY I.CDFILIAL, I.NRLANCTONF) I
                        WHERE ((IDSTATUS = 'A') OR (IDSTATUS = 'E'))
                          AND IDENTRSAIDOP = 'S'
                          AND I.NRLANCTONF = N.NRLANCTONF
                          AND I.CDFILIAL   = N.CDFILIAL
                          AND N.CDFILIRECE = F.CDFILIAL
                          AND F.CDFILIAL   = E.CDFILIAL(+)
                          AND E.IDTPENDEFILI(+) = NVL(F.IDENDEMISFIL,'P')
                          AND N.CDINSCESTA = IE.CDINSCESTA
                          AND N.CDEMPRESA  = IE.CDEMPRESA
                          AND NVL(E.CDPAIS,IE.CDPAIS)    = ES.CDPAIS
                          AND NVL(E.SGESTADO,IE.SGESTADO)= ES.SGESTADO
                          AND EI.CDPAIS    = IE.CDPAIS
                          AND EI.SGESTADO  = IE.SGESTADO
                        GROUP BY DECODE(NVL(F.IDENDEMISFIL,'P'),'I',EI.CDESTAEXPO,ES.CDESTAEXPO)) NF
                   GROUP BY NF.ESTADO) LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;

      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (V_CONTADOR, V_EMPRESA||C_NOTAS.DADOS||V_RESPONSAVL, V_SEQMAGNET);
   END LOOP;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GI','5.05.025'); END;
/

