CREATE TABLE USR_ZWJ (
WJ_IDNFEC         INTEGER           NOT NULL,
CDFILIAL          VARCHAR2(4)       NOT NULL,
NRLANCTONF        VARCHAR2(10)      NOT NULL,
WJ_EMPRESA        VARCHAR2(2)       NULL,
WJ_FILIAL         VARCHAR2(2)       NULL,
WJ_DOC            VARCHAR2(6)       NULL,
WJ_SERIE          VARCHAR2(3)       NULL,
WJ_CGC            VARCHAR2(14)      NOT NULL,
WJ_COND           VARCHAR2(3)       NULL,
WJ_DUPL           VARCHAR2(6)       NULL,
WJ_EMISSAO        DATE              NULL,
WJ_EST            VARCHAR2(2)       NULL,
WJ_FRETE          FLOAT             NULL,
WJ_DESPESA        FLOAT             NULL,
WJ_BASEICM        FLOAT             NULL,
WJ_VALICM         FLOAT             NULL,
WJ_BASEIPI        FLOAT             NULL,
WJ_VALIPI         FLOAT             NULL,
WJ_VALMERC        FLOAT             NULL,
WJ_VALBRUT        FLOAT             NULL,
WJ_TIPO           VARCHAR2(1)       NULL,
WJ_OPER           VARCHAR2(2)       NULL,
WJ_DESCONT        FLOAT             NULL,
WJ_NFORI          VARCHAR2(6)       NULL,
WJ_SERIORI        VARCHAR2(3)       NULL,
WJ_DTDIGIT        DATE              NULL,
WJ_CPROVA         VARCHAR2(14)      NULL,
WJ_BRICMS         FLOAT             NULL,
WJ_ICMSRET        FLOAT             NULL,
WJ_BASEFD         FLOAT             NULL,
WJ_CONTSOC        FLOAT             NULL,
WJ_IRRF           FLOAT             NULL,
WJ_FORMUL         VARCHAR2(1)       NULL,
WJ_NFORIG         VARCHAR2(6)       NULL,
WJ_SERORIG        VARCHAR2(3)       NULL,
WJ_ESPECIE        VARCHAR2(5)       NULL,
WJ_II             FLOAT             NULL,
WJ_BASIMP1        FLOAT             NULL,
WJ_BASIMP2        FLOAT             NULL,
WJ_BASIMP3        FLOAT             NULL,
WJ_BASIMP4        FLOAT             NULL,
WJ_BASIMP5        FLOAT             NULL,
WJ_BASIMP6        FLOAT             NULL,
WJ_VALIMP1        FLOAT             NULL,
WJ_VALIMP2        FLOAT             NULL,
WJ_VALIMP3        FLOAT             NULL,
WJ_VALIMP4        FLOAT             NULL,
WJ_VALIMP5        FLOAT             NULL,
WJ_VALIMP6        FLOAT             NULL,
WJ_HORA           VARCHAR2(5)       NULL,
WJ_INSS           FLOAT             NULL,
WJ_ISS            FLOAT             NULL,
WJ_HAWB           VARCHAR2(17)      NULL,
WJ_TIPO_NF        VARCHAR2(1)       NULL,
WJ_IPI            FLOAT             NULL,
WJ_ICMS           FLOAT             NULL,
WJ_FOB_R          FLOAT             NULL,
WJ_CIF            FLOAT             NULL,
WJ_BASEINS        FLOAT             NULL,
WJ_BASEIR         FLOAT             NULL,
WJ_PREFIXO        VARCHAR2(3)       NULL,
WJ_RECBMTO        DATE              NULL,
WJ_STATUS         VARCHAR2(1)       NULL,
WJ_BASEPS3        FLOAT             NULL,
WJ_VALPS3         FLOAT             NULL,
WJ_BASECF3        FLOAT             NULL,
WJ_VALCF3         FLOAT             NULL,
WJ_NFELETR        VARCHAR2(8)       NULL,
WJ_EMINFE         DATE              NULL,
WJ_HORNFE         VARCHAR2(6)       NULL,
WJ_CODNFE         VARCHAR2(8)       NULL,
WJ_CREDNFE        FLOAT             NULL,
WJ_RECISS         VARCHAR2(1)       NULL,
WJ_VALPIS         FLOAT             NULL,
WJ_VALCOFI        FLOAT             NULL,
WJ_VALCSLL        FLOAT             NULL,
WJ_VALIRF         FLOAT             NULL,
WJ_TPEDI          CHAR(1)           NOT NULL
   constraint CKC_WJ_TPEDI check (WJ_TPEDI in ('1','2', '3')),
WJ_DTGRV          DATE              NULL,
WJ_HRGRV          VARCHAR2(4)       NULL,
WJ_DTIMP          DATE              NULL,
WJ_HRIMP          VARCHAR2(4)       NULL,
CONSTRAINT PK_USR_ZWJ PRIMARY KEY(WJ_IDNFEC, CDFILIAL, NRLANCTONF)
)
/
CREATE SEQUENCE WJ_IDNFEC
INCREMENT BY 1 START WITH 1
/
ALTER TABLE USR_ZWJ MODIFY (WJ_DOC VARCHAR2(9))
/
ALTER TABLE USR_ZWJ MODIFY (WJ_NFORI VARCHAR2(9))
/
ALTER TABLE USR_ZWJ MODIFY (WJ_NFORIG VARCHAR2(9))
/

CREATE TABLE USR_ZWK
(
WK_IDNFEI        INTEGER              NOT NULL,
CDFILIAL         VARCHAR2(4)          NOT NULL,
NRLANCTONF       VARCHAR2(10)         NOT NULL,
WK_EMPRESA       VARCHAR2(2)          NULL,
WK_FILIAL        VARCHAR2(2)          NULL,
WK_COD           VARCHAR2(15)         NOT NULL,
WK_QUANT         FLOAT                NOT NULL,
WK_VUNIT         FLOAT                NOT NULL,
WK_TOTAL         FLOAT                NOT NULL,
WK_LOCAL         VARCHAR2(6)          NULL,
WK_CC            VARCHAR2(9)          NULL,
WK_VALICM        FLOAT                NULL,
WK_PICM          FLOAT                NULL,
WK_TES           VARCHAR2(3)          NULL,
WK_CF            VARCHAR2(5)          NULL,
WK_VALIPI        FLOAT                NULL,
WK_ICMSRET       FLOAT                NULL,
WK_BRICMS        FLOAT                NULL,
WK_NFORI         VARCHAR2(6)          NULL,
WK_SERIORI       VARCHAR2(3)          NULL,
WK_DESC          FLOAT                NULL,
WK_IPI           FLOAT                NULL,
WK_PEDIDO        VARCHAR2(6)          NULL,
WK_CGC           VARCHAR2(14)         NOT NULL,
WK_DOC           VARCHAR2(6)          NULL,
WK_DTDIGIT       DATE                 NULL,
WK_EMISSAO       DATE                 NULL,
WK_ITEMPC        VARCHAR2(4)          NULL,
WK_SERIE         VARCHAR2(3)          NULL,
WK_TIPO          VARCHAR2(1)          NULL,
WK_CUSTO         FLOAT                NULL,
WK_ITEMORI       VARCHAR2(2)          NULL,
WK_QTDEDEV       FLOAT                NULL,
WK_VALDEV        FLOAT                NULL,
WK_ITEM          VARCHAR2(4)          NULL,
WK_BASEICM       FLOAT                NULL,
WK_VALDESC       FLOAT                NULL,
WK_BASEIPI       FLOAT                NULL,
WK_FORMUL        VARCHAR2(1)          NULL,
WK_II            FLOAT                NULL,
WK_GERAPV        VARCHAR2(1)          NULL,
WK_NUMPV         VARCHAR2(6)          NULL,
WK_ITEMPV        VARCHAR2(2)          NULL,
WK_CONHEC        VARCHAR2(17)         NULL,
WK_CLASFIS       VARCHAR2(3)          NULL,
WK_BASIMP4       FLOAT                NULL,
WK_BASIMP5       FLOAT                NULL,
WK_BASIMP6       FLOAT                NULL,
WK_VALIMP4       FLOAT                NULL,
WK_VALIMP5       FLOAT                NULL,
WK_VALIMP6       FLOAT                NULL,
WK_CIF           FLOAT                NULL,
WK_ICMSCOM       FLOAT                NULL,
WK_TIPO_NF       VARCHAR2(1)          NULL,
WK_ALIQINS       FLOAT                NULL,
WK_ALIQIRR       FLOAT                NULL,
WK_ALIQISS       FLOAT                NULL,
WK_ALQIMP4       FLOAT                NULL,
WK_ALQIMP5       FLOAT                NULL,
WK_ALQIMP6       FLOAT                NULL,
WK_BASEINS       FLOAT                NULL,
WK_BASEIRR       FLOAT                NULL,
WK_BASEISS       FLOAT                NULL,
WK_DESPESA       FLOAT                NULL,
WK_QTDPEDI       FLOAT                NULL,
WK_RATEIO        VARCHAR2(1)          NULL,
WK_SEGURO        FLOAT                NULL,
WK_VALFRE        FLOAT                NULL,
WK_VALINS        FLOAT                NULL,
WK_VALIRR        FLOAT                NULL,
WK_VALISS        FLOAT                NULL,
WK_DATORI        DATE                 NULL,
WK_OPER          VARCHAR2(2)          NULL,
WK_CUSORI        FLOAT                NULL,
WK_CODISS        VARCHAR2(8)          NULL,
WK_DESCICM       FLOAT                NULL,
WK_BASEPS3       FLOAT                NULL,
WK_ALIQPS3       FLOAT                NULL,
WK_VALPS3        FLOAT                NULL,
WK_BASECF3       FLOAT                NULL,
WK_ALIQCF3       FLOAT                NULL,
WK_VALCF3        FLOAT                NULL,
WK_ICMSDIF       FLOAT                NULL,
WK_TPEDI         CHAR(1)              NOT NULL,
   constraint CKC_WK_TPEDI check (WK_TPEDI in ('1','2', '3')),
WK_DTGRV         DATE                 NULL,
WK_HRGRV         VARCHAR2(4)          NULL,
WK_DTIMP         DATE                 NULL,
WK_HRIMP         VARCHAR2(4)          NULL,
CONSTRAINT PK_USR_ZWK PRIMARY KEY(WK_IDNFEI, CDFILIAL, NRLANCTONF, WK_ITEM)
)
/
ALTER TABLE USR_ZWK MODIFY (WK_DOC VARCHAR2(9))
/
ALTER TABLE USR_ZWK MODIFY (WK_NFORI VARCHAR2(9))
/

CREATE OR REPLACE PROCEDURE EXP_NF_ENT_CUSTO(
     P_DTINICIAL IN NOTAFISCAL.DTENTRSAID%TYPE,
     P_DTFINAL   IN NOTAFISCAL.DTENTRSAID%TYPE)
AS
   V_DTGRV         DATE;
   V_HRGRV         VARCHAR2(04);

   V_FILIAL        VARCHAR(10);
   V_NOVOCODIGO    INTEGER;
   V_NUMA          INTEGER;
   V_SEQPROD       VARCHAR2(04);
   V_ITEM          VARCHAR2(02);
   V_SERIE         VARCHAR2(03);

   /* Variveis referente ao corpo da nota fiscal */
   V_BASEICMS      NUMBER;
   V_VALRICMS      NUMBER;
   V_BASEIPI       NUMBER;
   V_VALRIPI       NUMBER;
   V_BASEIRRF      NUMBER;
   V_VALRIRRF      NUMBER;
   V_BASEINSS      NUMBER;
   V_VALRINSS      NUMBER;
   V_VALRISS       NUMBER;
   V_BASEPIS       NUMBER;
   V_VALRPIS       NUMBER;
   V_VALRPISR      NUMBER;
   V_BASECOFINS    NUMBER;
   V_VALRCOFINS    NUMBER;
   V_VALRCOFINSR   NUMBER;
   V_BASECSLL      NUMBER;
   V_VALRCSLL      NUMBER;
   V_BASEPISST     NUMBER;
   V_VALRPISST     NUMBER;
   V_BASECOFINSST  NUMBER;
   V_VALRCOFINSST  NUMBER;

   /* Variveis referente aos itens da nota fiscal */
   V_VALRICMSIT    NUMBER;
   V_ALIQICMSIT    NUMBER;
   V_BASEICMSIT    NUMBER;
   V_VALRIPIIT     NUMBER;
   V_ALIQIPIIT     NUMBER;
   V_BASEIPIIT     NUMBER;
   V_VALRIRRFIT    NUMBER;
   V_ALIQIRRFIT    NUMBER;
   V_BASEIRRFIT    NUMBER;
   V_VALRISSIT     NUMBER;
   V_ALIQISSIT     NUMBER;
   V_BASEISSIT     NUMBER;
   V_VALRINSSIT    NUMBER;
   V_ALIQINSSIT    NUMBER;
   V_BASEINSSIT    NUMBER;
   V_BASEICMRETIT  NUMBER;
   V_VALRICMRETIT  NUMBER;
   V_BASEPISSTIT   NUMBER;
   V_VALRPISSTIT   NUMBER;
   V_ALIQPISSTIT   NUMBER;
   V_BASECOFSTIT   NUMBER;
   V_VALRCOFSTIT   NUMBER;
   V_ALIQCOFSTIT   NUMBER;
   V_VALRCSLLIT    NUMBER;
   V_ALIQCSLLIT    NUMBER;
   V_BASECSLLIT    NUMBER;
   V_VALRCOFIIT    NUMBER;
   V_ALIQCOFIIT    NUMBER;
   V_BASECOFIIT    NUMBER;
   V_VALRPISIT     NUMBER;
   V_ALIQPISIT     NUMBER;
   V_BASEPISIT     NUMBER;

   V_NRLANCESTQ    VARCHAR2(10);
   V_CDOPERADOR    VARCHAR2(12);
   V_VRNOTAFISC    NUMBER;
BEGIN
   V_DTGRV := NULL;
   V_HRGRV := NULL;

   /* Retorna data e hora de exportao */
   BEGIN
      SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
        INTO V_DTGRV, V_HRGRV
        FROM DUAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTGRV := NULL;
         V_HRGRV := NULL;
   END;

   DELETE FROM USR_ZWK;
   DELETE FROM USR_ZWJ;

   /* Verificao dos documentos de Entrada */
   FOR C_ENTRADA IN (SELECT N.CDEMPRESA,
                            N.CDINSCESTA,
                            N.CDFORNECED,
                            N.CDFILIAL,
                            N.NRLANCTONF,
                            N.DTENTRSAID,
                            N.CDFILIRECE,
                            SUBSTR(N.NRNOTAFISC,2,9) AS NRNOTAFISC,
                            SUBSTR(N.CDSERIEENTR,1,3) AS CDSERIEENTR,
                            TO_DATE(N.DTEMISSAO) AS DTEMISSAO,
                            SUBSTR(replace(replace(replace(N.NRINSJURNF, '-', ''),'.',''),'/',''),1,14) AS NRINSJURFORN,
                            LPAD(FO.CDFORMPGTO,3,'0') AS CDFORMPGTO,
                            E.SGESTADO,
                            N.VRPRODUTOS,
                            N.VRNOTAFISC,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '01') AS FRETE,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '06') AS DESPESA,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D', '02') AS DESCONTO,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'V', '07') AS BASICMSUBST,
                            VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '03') AS VRICMSUBST,
                            SUBSTR(T.CDEXTIPOOPER,1,2) AS CDEXTIPOOPER,
                            N.CDTIPOOPER,
                            SUBSTR(M.DSMODDOCFISC,1,INSTR(M.DSMODDOCFISC,'-')-1) AS ESPECIE
                       FROM NOTAFISCAL N, FORNECEDOR FO, ENDEFORN E, TIPOOPERAC T, FILIAL FI,
                            MODDOCFISC M, FILIAL FE,
                            (SELECT DISTINCT(CDFILIAL)
                                FROM FILGRUPFILI
                             WHERE USR_IDPROTHEUS = 'S') FG
                      WHERE (N.IDENTRSAIDOP = 'E')
                        AND (N.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL)
                        AND (N.IDSISTEMA IN ('DFE','EST') OR N.IDSISTEMA IS NULL)
                        AND (N.CDFORNECED = FO.CDFORNECED (+))
                        AND (E.CDFORNECED (+) = N.CDFORNECED)
                        AND (E.IDTPENDEFORN (+) = 'P')
                        AND (N.CDFILIEMIT = FI.CDFILIAL (+))
                        AND (T.IDENTRSAIDOP = N.IDENTRSAIDOP)
                        AND (T.CDTIPOOPER = N.CDTIPOOPER)
                        AND (M.CDMODDOCFISC = N.CDMODDOCFISC)
                        AND (N.CDFILIRECE = FE.CDFILIAL)
                        AND (FE.CDFILIAL = FG.CDFILIAL)
                        AND NOT EXISTS (SELECT CDFILIAL
                                          FROM NFRELACPEXOL O
                                         WHERE O.CDFILIAL = N.CDFILIAL
                                           AND O.NRLANCTONF = N.NRLANCTONF))
   LOOP
      V_BASEICMS     := 0;
      V_VALRICMS     := 0;
      V_BASEIPI      := 0;
      V_VALRIPI      := 0;
      V_BASEIRRF     := 0;
      V_VALRIRRF     := 0;
      V_BASEINSS     := 0;
      V_VALRINSS     := 0;
      V_VALRISS      := 0;
      V_BASEPIS      := 0;
      V_VALRPIS      := 0;
      V_VALRPISR     := 0;
      V_BASECOFINS   := 0;
      V_VALRCOFINS   := 0;
      V_VALRCOFINSR  := 0;
      V_BASECSLL     := 0;
      V_VALRCSLL     := 0;
      V_BASEPISST    := 0;
      V_VALRPISST    := 0;
      V_BASECOFINSST := 0;
      V_VALRCOFINSST := 0;
      V_VALRCSLLIT   := 0;
      V_ALIQCSLLIT   := 0;
      V_BASECSLLIT   := 0;
      V_VALRCOFIIT   := 0;
      V_ALIQCOFIIT   := 0;
      V_BASECOFIIT   := 0;
      V_VALRPISIT    := 0;
      V_ALIQPISIT    := 0;
      V_BASEPISIT    := 0;

      V_SERIE        := NULL;

      V_NRLANCESTQ := '';
      V_CDOPERADOR := '';

      SELECT MAX(NRLANCESTQ), MAX(CDOPERADOR)
        INTO V_NRLANCESTQ, V_CDOPERADOR
        FROM LANCTOESTOQ
       WHERE CDFILIAL   = C_ENTRADA.CDFILIAL
         AND NRLANCTONF = C_ENTRADA.NRLANCTONF;

      SELECT MAX(CDGRUPFILI)
        INTO V_FILIAL
        FROM FILGRUPFILI
       WHERE CDFILIAL = C_ENTRADA.CDFILIRECE
         AND USR_IDPROTHEUS = 'S';

      IF NOT V_FILIAL IS NULL THEN

         IF SUBSTR(C_ENTRADA.CDSERIEENTR,1,1) <> '-' THEN
            V_SERIE := C_ENTRADA.CDSERIEENTR;
         END IF;

         /* Valores referente a impostos */
         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEICMS, V_VALRICMS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '00';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEICMS := 0;
               V_VALRICMS := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEIPI, V_VALRIPI
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '10';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEIPI := 0;
               V_VALRIPI := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEIRRF, V_VALRIRRF
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '20';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEIRRF := 0;
               V_VALRIRRF := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEINSS, V_VALRINSS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '40';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEINSS := 0;
               V_VALRINSS := 0;
         END;

         BEGIN
            SELECT VRTOTIMPONF
              INTO V_VALRISS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '30';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VALRISS := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEPIS, V_VALRPIS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '50';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEPIS := 0;
               V_VALRPIS := 0;
         END;

         BEGIN
            SELECT VRTOTIMPONF
              INTO V_VALRPISR
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '51';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VALRPISR := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASECOFINS, V_VALRCOFINS
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '60';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASECOFINS := 0;
               V_VALRCOFINS := 0;
         END;

         BEGIN
            SELECT VRTOTIMPONF
              INTO V_VALRCOFINSR
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '61';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VALRCOFINSR := 0;
         END;

         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASECSLL, V_VALRCSLL
              FROM IMPOSNFTOT
             WHERE CDFILIAL = C_ENTRADA.CDFILIAL
               AND NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND CDIMPOSTO = '80';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASECSLL := 0;
               V_VALRCSLL := 0;
         END;

         /* PIS substituio tributria */
         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASEPISST, V_VALRPISST
              FROM IMPOSNFTOT IM, IMPOSTO I
             WHERE I.CDIMPOSTO = '50'
               AND IM.CDFILIAL = C_ENTRADA.CDFILIAL
               AND IM.NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND IM.CDIMPOSTO = I.CDIMPOSTRIB;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASEPISST := 0;
               V_VALRPISST := 0;
         END;

         /* COFINS substituio tributria */
         BEGIN
            SELECT VRTOTBCALCNF, VRTOTIMPONF
              INTO V_BASECOFINSST, V_VALRCOFINSST
              FROM IMPOSNFTOT IM, IMPOSTO I
             WHERE I.CDIMPOSTO = '60'
               AND IM.CDFILIAL = C_ENTRADA.CDFILIAL
               AND IM.NRLANCTONF = C_ENTRADA.NRLANCTONF
               AND IM.CDIMPOSTO = I.CDIMPOSTRIB;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_BASECOFINSST := 0;
               V_VALRCOFINSST := 0;
         END;

         /* Retorna o sequencial para a tabela */
         BEGIN
            SELECT WJ_IDNFEC.NEXTVAL
              INTO V_NOVOCODIGO
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NOVOCODIGO := 1;
         END;

         /* Insere corpo de nota fiscal */
         INSERT INTO USR_ZWJ
            (CDFILIAL, NRLANCTONF, WJ_IDNFEC, WJ_EMPRESA, WJ_FILIAL, WJ_DOC, WJ_SERIE,
             WJ_CGC, WJ_EMISSAO, WJ_EST, WJ_FRETE, WJ_DESPESA, WJ_COND, WJ_BASEICM,
             WJ_VALICM, WJ_BASEIPI, WJ_VALIPI, WJ_VALMERC, WJ_VALBRUT, WJ_TIPO, WJ_DESCONT,
             WJ_BRICMS, WJ_ICMSRET, WJ_IRRF, WJ_FORMUL, WJ_BASIMP4, WJ_BASIMP5, WJ_BASIMP6,
             WJ_VALIMP4, WJ_VALIMP5, WJ_VALIMP6, WJ_INSS, WJ_ISS, WJ_OPER, WJ_ICMS,
             WJ_BASEINS, WJ_BASEIR, WJ_VALPIS, WJ_VALCOFI, WJ_VALCSLL, WJ_VALIRF, WJ_BASEPS3, WJ_VALPS3,
             WJ_BASECF3, WJ_VALCF3, WJ_NFELETR, WJ_ESPECIE, WJ_DTDIGIT, WJ_TPEDI, WJ_DTGRV, WJ_HRGRV)
         VALUES
            (C_ENTRADA.CDFILIAL, C_ENTRADA.NRLANCTONF, V_NOVOCODIGO, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), C_ENTRADA.NRNOTAFISC, V_SERIE,
             SUBSTR(C_ENTRADA.NRINSJURFORN,1,14) ,C_ENTRADA.DTEMISSAO, C_ENTRADA.SGESTADO, C_ENTRADA.FRETE, C_ENTRADA.DESPESA, C_ENTRADA.CDFORMPGTO, V_BASEICMS,
             V_VALRICMS, V_BASEIPI, V_VALRIPI, C_ENTRADA.VRPRODUTOS, C_ENTRADA.VRNOTAFISC, 'N', C_ENTRADA.DESCONTO,
             ROUND(C_ENTRADA.BASICMSUBST,5), ROUND(C_ENTRADA.VRICMSUBST,5), V_VALRIRRF, 'N', 0, V_BASECOFINS, V_BASEPIS,
             0, V_VALRCOFINS, V_VALRPIS, V_VALRINSS, V_VALRISS, C_ENTRADA.CDEXTIPOOPER, 0,
             V_BASEINSS, V_BASEIRRF, V_VALRPISR, V_VALRCOFINSR, V_VALRCSLL, 0, V_BASEPISST, V_VALRPISST,
             V_BASECOFINSST, V_VALRCOFINSST, NULL, C_ENTRADA.ESPECIE, C_ENTRADA.DTENTRSAID, '1', V_DTGRV, V_HRGRV);

         /* Verificao dos itens da nota fiscal */
         FOR C_ITEMENTRADA IN (SELECT I.NRSEQITPROD, P.CDARVPROD, I.QTITEMPROD, I.VRUNITITEM, I.CDFISOPEITEM,
                                      I.VRTOTAITEM, I.VRDESCITEM, I.CDSITUTRIBPR, I.VRCONTITEM, T.TOTALITEM
                                 FROM ITEMPRODUTO I, PRODUTO P,
                                      (SELECT SUM(VRTOTAITEM) AS TOTALITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                                          AND NRLANCTONF = C_ENTRADA.NRLANCTONF) T
                                WHERE I.CDFILIAL = C_ENTRADA.CDFILIAL
                                  AND I.NRLANCTONF = C_ENTRADA.NRLANCTONF
                                  AND I.CDPRODUTO = P.CDPRODUTO
                              )
         LOOP
            V_VALRICMSIT   := 0;
            V_ALIQICMSIT   := 0;
            V_BASEICMSIT   := 0;
            V_VALRIPIIT    := 0;
            V_ALIQIPIIT    := 0;
            V_BASEIPIIT    := 0;
            V_VALRIRRFIT   := 0;
            V_ALIQIRRFIT   := 0;
            V_BASEIRRFIT   := 0;
            V_VALRISSIT    := 0;
            V_ALIQISSIT    := 0;
            V_BASEISSIT    := 0;
            V_VALRINSSIT   := 0;
            V_ALIQINSSIT   := 0;
            V_BASEINSSIT   := 0;
            V_BASEICMRETIT := 0;
            V_VALRICMRETIT := 0;
            V_BASEPISSTIT  := 0;
            V_VALRPISSTIT  := 0;
            V_ALIQPISSTIT  := 0;
            V_BASECOFSTIT  := 0;
            V_VALRCOFSTIT  := 0;
            V_ALIQCOFSTIT  := 0;

            /* Valores referente a impostos */
            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRICMSIT, V_ALIQICMSIT, V_BASEICMSIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '00'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRICMSIT := 0;
                  V_ALIQICMSIT := 0;
                  V_BASEICMSIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRIPIIT, V_ALIQIPIIT, V_BASEIPIIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '10'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRIPIIT := 0;
                  V_ALIQIPIIT := 0;
                  V_BASEIPIIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRIRRFIT, V_ALIQIRRFIT, V_BASEIRRFIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '20'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRIRRFIT := 0;
                  V_ALIQIRRFIT := 0;
                  V_BASEIRRFIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRISSIT, V_ALIQISSIT, V_BASEISSIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '30'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRISSIT := 0;
                  V_ALIQISSIT := 0;
                  V_BASEISSIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRINSSIT, V_ALIQINSSIT, V_BASEINSSIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '40'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRINSSIT := 0;
                  V_ALIQINSSIT := 0;
                  V_BASEINSSIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRCSLLIT, V_ALIQCSLLIT, V_BASECSLLIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '80'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRCSLLIT := 0;
                  V_ALIQCSLLIT := 0;
                  V_BASECSLLIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRCOFIIT, V_ALIQCOFIIT, V_BASECOFIIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '60'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRCOFIIT := 0;
                  V_ALIQCOFIIT := 0;
                  V_BASECOFIIT := 0;
            END;

            BEGIN
               SELECT VRIMPOSTOIT, VRALIQITEM, VRBASECALCIT
                 INTO V_VALRPISIT, V_ALIQPISIT, V_BASEPISIT
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL = C_ENTRADA.CDFILIAL
                  AND NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND NRSEQITPROD = C_ITEMENTRADA.NRSEQITPROD
                  AND CDIMPOSTO = '50'
                  AND NRITPROIMPOS = '1';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VALRPISIT := 0;
                  V_ALIQPISIT := 0;
                  V_BASEPISIT := 0;
            END;

            /* PIS substituio tributria */
            BEGIN
               SELECT VRBASECALCIT, VRIMPOSTOIT, VRALIQITEM
                 INTO V_BASEPISSTIT, V_VALRPISSTIT, V_ALIQPISSTIT
                 FROM ITEMPROIMPOS IM, IMPOSTO I
                WHERE I.CDIMPOSTO = '50'
                  AND IM.CDFILIAL = C_ENTRADA.CDFILIAL
                  AND IM.NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND IM.NRITPROIMPOS = '1'
                  AND IM.CDIMPOSTO = I.CDIMPOSTRIB;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_BASEPISSTIT := 0;
                  V_VALRPISSTIT := 0;
                  V_ALIQPISSTIT := 0;
            END;

            /* COFINS substituio tributria */
            BEGIN
               SELECT VRBASECALCIT, VRIMPOSTOIT, VRALIQITEM
                 INTO V_BASECOFSTIT, V_VALRCOFSTIT, V_ALIQCOFSTIT
                 FROM ITEMPROIMPOS IM, IMPOSTO I
                WHERE I.CDIMPOSTO = '60'
                  AND IM.CDFILIAL = C_ENTRADA.CDFILIAL
                  AND IM.NRLANCTONF = C_ENTRADA.NRLANCTONF
                  AND IM.NRITPROIMPOS = '1'
                  AND IM.CDIMPOSTO = I.CDIMPOSTRIB;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_BASECOFSTIT := 0;
                  V_VALRCOFSTIT := 0;
                  V_ALIQCOFSTIT := 0;
            END;

            V_BASEICMRETIT := ((C_ITEMENTRADA.VRTOTAITEM / C_ITEMENTRADA.TOTALITEM) * C_ENTRADA.BASICMSUBST);
            V_VALRICMRETIT := ((C_ITEMENTRADA.VRTOTAITEM / C_ITEMENTRADA.TOTALITEM) * C_ENTRADA.VRICMSUBST);

            /* Insere itens da nota fiscal */
            INSERT INTO USR_ZWK
               (CDFILIAL, NRLANCTONF, WK_IDNFEI, WK_EMPRESA, WK_FILIAL, WK_DOC, WK_SERIE,
                WK_CGC, WK_EMISSAO, WK_ITEM, WK_COD, WK_QUANT, WK_VUNIT,
                WK_TOTAL, WK_CC, WK_CF, WK_VALICM, WK_VALIPI, WK_IPI, WK_PICM,
                WK_BASEICM, WK_BASEIPI, WK_ICMSRET, WK_BRICMS, WK_DESC, WK_ICMSCOM, WK_TIPO,
                WK_FORMUL, WK_CLASFIS, WK_BASIMP4, WK_BASIMP5, WK_BASIMP6, WK_VALIMP4, WK_VALIMP5,
                WK_VALIMP6, WK_BASEIRR, WK_ALIQIRR, WK_VALIRR, WK_BASEISS, WK_ALIQISS, WK_VALISS,
                WK_BASEINS, WK_ALIQINS, WK_VALINS, WK_ALIQCF3, WK_VALCF3, WK_VALPS3, WK_BASECF3,
                WK_BASEPS3, WK_ALIQPS3, WK_CUSTO, WK_DTDIGIT, WK_TPEDI, WK_DTGRV, WK_HRGRV)
            VALUES
               (C_ENTRADA.CDFILIAL, C_ENTRADA.NRLANCTONF, V_NOVOCODIGO, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), C_ENTRADA.NRNOTAFISC, V_SERIE,
                SUBSTR(C_ENTRADA.NRINSJURFORN,1,14), C_ENTRADA.DTEMISSAO, C_ITEMENTRADA.NRSEQITPROD, SUBSTR(C_ITEMENTRADA.CDARVPROD,1,15), C_ITEMENTRADA.QTITEMPROD, C_ITEMENTRADA.VRUNITITEM,
                C_ITEMENTRADA.VRTOTAITEM, C_ENTRADA.CDFILIRECE, SUBSTR(C_ITEMENTRADA.CDFISOPEITEM,1,5), V_VALRICMSIT, V_VALRIPIIT, V_ALIQIPIIT, V_ALIQICMSIT,
                V_BASEICMSIT, V_BASEIPIIT, ROUND(V_VALRICMRETIT,5), ROUND(V_BASEICMRETIT,5), C_ITEMENTRADA.VRDESCITEM, 0, 'N',
                'N', C_ITEMENTRADA.CDSITUTRIBPR, 0, V_BASECOFIIT, V_BASEPISIT, 0, V_VALRCOFIIT,
                V_VALRPISIT, V_BASEIRRFIT, V_ALIQIRRFIT, V_VALRIRRFIT, V_BASEISSIT, V_ALIQISSIT, V_VALRISSIT,
                V_BASEINSSIT, V_ALIQINSSIT, V_VALRINSSIT, V_ALIQCOFSTIT, V_VALRCOFSTIT, V_VALRPISSTIT, V_BASECOFSTIT,
                V_BASEPISSTIT, V_ALIQPISSTIT, C_ITEMENTRADA.VRCONTITEM, C_ENTRADA.DTENTRSAID, '1', V_DTGRV, V_HRGRV);
         END LOOP;
      END IF;
   END LOOP;
   COMMIT;
END;
/
/*
-- VERSAO --
BEGIN ATUVEROBJ('EXP_NF_ENT_CUSTO','5.09.000'); END;
/
*/
