var Fis41200_Configuracao_Controller = function(ZhFilterPreferences, ScreenService, templateManager, restEngine, General) {

    // Armazena o escopo atual.
    var self = this;
    
    self.openConfig = function(widget) {
        ScreenService.openWindow("fis_acessorias#fis41200_configuracao");
            
    };
    
    self.changeActions = function (widget){
        General.callRestEngine('fis#/crud/configurasmtp','FilterData', []).then(
            function(sucesso){
                if(sucesso.dataset.configurasmtp.length == 0){
                    widget.actions.forEach(function(action){
                        if(action.name == 'adicionar'){
                            action.isVisible = true;
                        } else if(action.name == 'edit'){
                            action.isVisible = false;
                        }
                    });
                    widget.reload();
                } else {
                    widget.actions.forEach(function(action){
                        if(action.name == 'adicionar'){
                            action.isVisible = false;
                        } else if(action.name == 'edit'){
                            action.isVisible = true;
                        }
                    });
                    widget.currentRow = sucesso.dataset.configurasmtp[0];
                    widget.reload();
                }
            }
        );
    };
    
    self.reloadAndMoveToFirst = function (field){
        var widget = templateManager.container.getWidget('fis75001_parametros_EFD_reinf_form');
        if (!Util.isEmptyOrBlank(field.value())){
            widget.reload().then(function (){
                var existeData = (widget.dataSource.data[0]) ? true : false;
                widget.currentRow = (existeData) ? widget.dataSource.data[0] : {};
                widget.currentRow.CDEMPRESA = field.value();
                widget.getField('DSDIRCERTIFICADO').fileList = widget.currentRow.DSDIRCERTIFICADO;
                widget.getAction('edit').isVisible = existeData;
                widget.getAction('edit').readOnly  = !existeData;
                widget.getAction('adicionar').isVisible = !existeData;
                widget.getAction('adicionar').readOnly  = existeData;
                widget.redraw();
            }, function (error){
                ScreenService.errorNotification(error);
                widget.getAction('edit').readOnly = false;
                widget.getAction('adicionar').readOnly = false;
                widget.redraw();
            });
        } else {
            widget.currentRow = {};
            widget.getAction('edit').isVisible = false;
            widget.getAction('edit').readOnly  = false;
            widget.getAction('adicionar').isVisible = true;
            widget.getAction('adicionar').readOnly = true;
            widget.redraw();
        }
    };
    
    self.saveCrud = function (widget){
        var currentRow  = widget.currentRow;
        if (widget.isValid()){
            General.saveCrud(widget).then(function(sucesso) {
                aftersave(widget);
                widget.currentRow.__is_new = false;
            });
        }
    };
    
    function aftersave(widget){
        General.formWidgetSwitchTemplate(widget);
        widget.list();
        widget.reload().then(function() {
            var existeData = (widget.dataSource.data[0]) ? true : false;
            widget.currentRow = (existeData) ? widget.dataSource.data[0] : {};
        });
        templateManager.container.getWidget('fis41100_contatos').enabled = true;
        templateManager.container.getWidget('fis41100_contatos').reload();
        templateManager.updateTemplate();
    }
    
    self.widgetEdit = function (widget, isNew){
        if(isNew){
            widget.currentRow.__is_new = true;
            widget.currentRow.IDCRIPTSSL = 'N';
            widget.currentRow.IDCRIPTTLS = 'N';
        }
        General.widgetEdit(widget);
        templateManager.container.getWidget('fis41100_contatos').enabled = false;
        templateManager.container.getWidget('fis41100_contatos').reload();
        templateManager.updateTemplate();
    };
    
    self.cancel = function (args){
        General.backOrCancel(args);
        General.formWidgetSwitchTemplate(args.owner.widget);
        args.owner.widget.list();
        templateManager.container.getWidget('fis41100_contatos').enabled = true;
        templateManager.container.getWidget('fis41100_contatos').reload();
        templateManager.updateTemplate();
    };
    
    self.empresaOnChange = function(widget){
        if(widget.currentRow.NMEMPRESA && widget.currentRow.NMEMPRESA != ''){
            widget.getField('CDINSCESTA').readOnly = false;
            widget.getField('CDINSCESTA').clearValue();
        } else {
            widget.getField('CDINSCESTA').readOnly = true;
            widget.getField('CDINSCESTA').clearValue();
        }
        widget.getField('CDINSCESTA').reload();
    };
    
    self.openFilterContatos = function(widget){
        var rowsToSet = {};
        ZhFilterPreferences.setOriginalFilter(widget.id, rowsToSet);
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };
    
    self.newRowContatos = function(widget){
        widget.newRow();
        widget.currentRow.IDAPURAAUTO = 'N';
        widget.currentRow.IDEXPORTAUTO = 'N';
    };
    
    self.saveContatos = function (widget){
        if(widget.isValid()){    
            if(widget.currentRow.CDEMPRESA == ''){
                widget.currentRow.CDEMPRESA = 'T';
            }
            
            widget.currentRow.NRORG = getLocalVar('NRORG');
            widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
            General.callRestEngine('fis_acessorias#/saveContatos','Row', widget.currentRow).then(
                function (sucesso){
                    ScreenService.goBack();
                    widget.reload();
                }, function (error){
                    ScreenService.showMessage(error.dataset.error);
                }
            );
        }
        
    };
    
    self.editContatos = function (widget){
        if(!(Array.isArray(widget.currentRow.CDEMPRESA))){
            widget.currentRow.CDEMPRESA = [widget.currentRow.CDEMPRESA];
            widget.currentRow.NMEMPRESA = [widget.currentRow.NMEMPRESA];
            widget.getField('CDEMPRESA').reload();
            if(widget.currentRow.CDINSCRICAO && widget.currentRow.CDINSCRICAO != ""){
                widget.currentRow.CDINSCRICAO = [widget.currentRow.CDINSCRICAO];
                widget.getField('CDINSCRICAO').reload();
            }
            General.edit(widget);
        } else {
            General.edit(widget);
        }
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis41200_Configuracao_Controller', Fis41200_Configuracao_Controller);
});
