var Fis97000_dctf_Controller = function(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil, ZHPromise) {

    // Armazena o escopo atual.
    var self = this;

    this.exportar = function(widget) {
            // Verifica se todos os campos obrigatórios foram preenchidos.
            if (widget.isValid()) {
    
                // Atribui aos fields da widget principal, os vaores da widget
                // 'parametrosGeraidDacAl'
                var DCTF = templateManager.container.getWidget('FED_DCTF');
                var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
                parametrosWidget.currentRow.CDEMPRESA = DCTF.currentRow.CDEMPRESA;
                parametrosWidget.currentRow.DTREFINI = DCTF.currentRow.DTREFINI;
                parametrosWidget.currentRow.NMARQUIVO = DCTF.currentRow.NMARQUIVO;
                parametrosWidget.currentRow.NRORG = getLocalVar('NRORG');
                preencheFieldsOcultosWidgetPrincipal(widget, parametrosWidget);
                var row = parametrosWidget.currentRow;            
                var route = "fis#/exportarDCTF";
                var message = Messages_fiscal.EXPORTANDO_DIRF;
                ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    
    var preencheFieldsOcultosWidgetPrincipal = function(widget, parametrosWidget){
        widget.currentRow.CDTPDECLARACAO = parametrosWidget.currentRow.CDTPDECLARACAO;
        widget.currentRow.NUMRECIBO = parametrosWidget.currentRow.NUMRECIBO; 
        widget.currentRow.CDNATDECLARANTE = parametrosWidget.currentRow.CDNATDECLARANTE;
        widget.currentRow.CDINDSOCIO = parametrosWidget.currentRow.CDINDSOCIO;
        widget.currentRow.CDDEPOSITCRED = parametrosWidget.currentRow.CDDEPOSITCRED; 
        widget.currentRow.CDTPINVEST = parametrosWidget.currentRow.CDTPINVEST; 
        widget.currentRow.CDRENDPGEXT = parametrosWidget.currentRow.CDRENDPGEXT; 
        widget.currentRow.CDINDPLANSD = parametrosWidget.currentRow.CDINDPLANSD; 
        widget.currentRow.CDPGIMUISE = parametrosWidget.currentRow.CDPGIMUISE; 
        widget.currentRow.CDFUNPUBDIRPRIV = parametrosWidget.currentRow.CDFUNPUBDIRPRIV; 
        widget.currentRow.CDSITESP = parametrosWidget.currentRow.CDSITESP; 
        widget.currentRow.DTEVENTO = parametrosWidget.currentRow.DTEVENTO; 
        widget.currentRow.CDREPRES = parametrosWidget.currentRow.CDREPRES;       
    }; 
    
    /*
     * Função para abrir o formulário com as parametrizações do DAC-AL.
     * Altera o parâmetro "wasLoaded" da widget, que indica se a parametrização
     * foi revisada antes do arquivo ter sido exportado.
     */
    var openTabParametrosGerais = function(widget) {
        
        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
        // Recarrega os dados parametrizados.
        parametrosWidget.reload().then(function() {
            // Redesenha a widget, fazendo com que apareçam os dados carregados.
            parametrosWidget.redraw();
        });
        // Abre a widget da tabbed 'parametrosGerais'
        widget.currentWidget = parametrosWidget;
        parametrosWidget.activate();
    };
    
    this.save = function(widget){
      // Seleciona a widget conforme o arquivo selecionado.
       var DCTF = templateManager.container.getWidget('FED_DCTF');
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
        parametrosWidget.currentRow.CDEMPRESA = DCTF.currentRow.CDEMPRESA;
        parametrosWidget.currentRow.DTREFINI = DCTF.currentRow.DTREFINI;
        parametrosWidget.currentRow.NMARQUIVO = DCTF.currentRow.NMARQUIVO;
        parametrosWidget.currentRow.NRORG = getLocalVar('NRORG');
        General.callRestEngine('fis_acessorias#/saveDCTF','Row', widget.currentRow).then(
                    function(success){
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Salvo com sucesso.');
                        ScreenService.goBack();
                        widget.reload();
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
    };
    
     this.setLoadedParameters = function(parametrosWidget) {
        var widget = templateManager.container.getWidget("FED_DCTF");

        // Verifica se há alguma parametrização retornada.
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como o primeiro dado no array retornado.
            parametrosWidget.moveToFirst();

            // Configurações específicas para os parâmetros do SPED Fiscal.
            if (parametrosWidget.name == "parametrosGeraisDCTF") {
                var currentRow = parametrosWidget.currentRow;
                // O campo "CDOBRIGAREGBL1" possui a parametrização da obrigatoriedades dos registros (Bloco 1).
                // Os valores são armazenados em uma String na ordem de aparição dos campos,
                // sendo 'N' para "falso" e 'S' para "verdadeiro".
                var codigosArray = currentRow.CDOBRIGAREGBL1.split("");

                // Adiciona no array todos os valores marcados.
                currentRow.CDOBRIGARRAY = [];
                if (codigosArray[0] == 'S') {
                    // Registro 1100.
                    currentRow.CDOBRIGARRAY.push(0);
                }
                if (codigosArray[1] == 'S') {
                    // Registro 1200.
                    currentRow.CDOBRIGARRAY.push(1);
                }
                if (codigosArray[2] == 'S') {
                    // Registro 1300.
                    currentRow.CDOBRIGARRAY.push(2);
                }
                if (codigosArray[3] == 'S') {
                    // Registro 1390.
                    currentRow.CDOBRIGARRAY.push(3);
                }
                if (codigosArray[4] == 'S') {
                    // Registro 1400.
                    currentRow.CDOBRIGARRAY.push(4);
                }
                if (codigosArray[5] == 'S') {
                    // Registro 1500.
                    currentRow.CDOBRIGARRAY.push(5);
                }
                if (codigosArray[6] == 'S') {
                    // Registro 1600.
                    currentRow.CDOBRIGARRAY.push(6);
                }
                if (codigosArray[7] == 'S') {
                    // Registro 1700.
                    currentRow.CDOBRIGARRAY.push(7);
                }
                if (codigosArray[8] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(8);
                }
                if (codigosArray[9] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(9);
                }
                if (codigosArray[10] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(10);
                }
                if (codigosArray[11] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(11);
                }
                if (codigosArray[12] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(12);
                }
            }
        }
        else {
            // Seta a widget em modo de novo dado, para inserir a parametrização.
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = widget.currentRow.CDEMPRESA;
        }

        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = widget.currentRow.NMEMPRESA;

    };
    
     this.beforeExitParametrosGerais = function(parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não
        // estiver em modo de inserção, mas sim de edição.
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    
    var setParametersVerified = function(parametrosWidget) {
        var DCTFFiscalIsSelected = parametrosWidget.name == "parametrosGeraisDCTF";
        var currentRow = parametrosWidget.currentRow;
        // Seta a propriedade que indica se a parametrização foi verificada.
        if (DCTFFiscalIsSelected) {
            var spedWidget = templateManager.container.getWidget("FED_DCTF");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa  selecionados.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
            spedWidget.currentRow.REG1400 = (Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1);
        }
        else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    
    
    
    
    

};



Configuration(function(ContextRegister) {
    ContextRegister.register('Fis97000_dctf_Controller', Fis97000_dctf_Controller);
});
